!============================================================
! sdkLCS.inc -- List Column Sorter class implementation
!
!  2010 Simon Kemp, simon@sdk.demon.co.uk
!
!  This software is provided 'as-is', without any express or implied
!  warranty.  In no event will the author be held liable for any damages
!  arising from the use of this software.
!
!  Permission is granted to anyone to use this software for any purpose,
!  including commercial applications, and to alter it and redistribute it
!  freely, subject to the following restrictions:
!
!  1. The origin of this software must not be misrepresented; you must not
!     claim that you wrote the original software. If you use this software
!     in a product, an acknowledgment in the product documentation would be
!     appreciated but is not required.
!
!  2. Altered source versions must be plainly marked as such, and must not be
!     misrepresented as being the original software.
!
!  3. This notice may not be removed or altered from any source distribution.
!
!============================================================

sdkLCScolq      queue,type
column            long
columnwho         string(100)
headertext        string(255)
sortoptions       long
fieldno           long
isastring         long
                end

sdkLCSkeyq      queue,type
level             long
column            long
direction         long
fieldno           long
sortoptions       long
isastring         long
                end
                
sdkLCSLocate    string(' <8>abcdefghijklmnopqrstuvwxyz0123456789' & | ! 8=BSKey
                           'ABCDEFGHIJKLMNOPQRSTUVWXYZ<189><190><191><192>') ! 189=- 190=. 191=/ 192='
                           
sdkLCS::NotTagged       equate(1)                            
sdkLCS::Tagged          equate(2)                            
sdkLCS::BlockTagging    equate(3)                            

sdkLCS      class,type,module('sdklcs.clw'),link('sdklcs.clw', 1),dll(0)
Init                procedure(long thelistfeq, *queue listqueue, long tweaklineheight=0)
InitCalled          procedure,long 
ChangeQueue         procedure(*queue listqueue)  
Kill                procedure
SetColumnOptions    procedure(<string nosorting>, <string casesensitive>, <string restrictsort>, <string overridecolumnfields>)
SetStrings          procedure(string poverride)    
SetInitialSort      procedure(<*string variablesort>, <string initialsort>, long locked=0)
SetLocator          procedure(long pFEQ, *string pUse, long pPromptFEQ=0, long pIncremental=0)
SetTagColumn        procedure(long pNumber, *string pData, *long pIcon, long pClearFEQ=0)  
Start               procedure
NewHeader           procedure(long pcolumnnumber)  
NewHeader           procedure(long pcolumnnumber, string pheadertext)  
ShowHeaders         procedure(long reset=0, long reload=0)
ShowSort            procedure,string
SortQ               procedure(long dontrelocate=0),virtual
TakeEvent           procedure,long,proc
UnSortQ             procedure
SetNoSorting        procedure(long pcolumnnumber, long pnosorting=1),long,proc
ColumnIsSorted      procedure(long pcolumnnumber),long
SetSort             procedure(long ps1, long ps2=0, long ps3=0),long,proc
GetPosition         procedure(string pLocate),long 
PropSetter          procedure(long pFEQ, long pProp, string pValue) 
Debug               procedure(string pWhat)  
HasTags             procedure,long 
ClearTags           procedure 
TagCount            procedure,long 
SortTwoThings       procedure(*? pThing1, *? pThing2) 

ActionKeyCode       procedure(long thekeycode),private
FieldInGroup        procedure,long,private
RegionDown          procedure,private
RowSelectedInGroup  procedure,long,private
Construct           procedure,private
Destruct            procedure,private

headereffects       long
multikey            long
prependindicators   long
showcursoronsort    long
sortonchanges       long
columnoneislocator  long

alertkeystd         long,protected
alertkeymulti       long,protected
alertkeyclear       long,protected
blockcolumnoptions  long,protected
columns             &sdkLCScolq,protected
initcalled_         long,protected 
initialsort         string(100),protected
keys                &sdkLCSkeyq!,protected
listfeq             long,protected
listfrom            &queue,protected
locked              long
stickysort          &string,protected
storechanges        long,protected
regionfeq           long,protected
lastfield           long,protected
lastkeycode         long,protected
lastcolumn          long,protected
locatorfeq          long,protected
locatoruse          &string,protected
locatorpromptfeq    long,protected
locatorincremental  long,protected 
incrementallocator  cstring(51),protected    
alertedlocator      long,protected 
tagcolumn           long,protected  
tagdata             &string,protected  
tagicon             &long,protected   
tagclearfeq         long,protected 
lasttagpointer      long,protected
lasttagaction       long,protected
            end

SDKLCSkeyqref &sdkLCSkeyq,thread
